package steps
{
import org.morefluent.integrations.flexunit3.*;
import org.uinput.*;

public class LoginDomainStep
{
    public function LoginDomainStep()
    {
    }

    [DomainStep("The login screen is displayed")]
    public function switchToLoginScreen():void
    {
        var app:SampleApp = container(":SampleApp").component;
        app.model.applicationState = null;
    }

    [DomainStep('I cleared user name')]
    public function clearUserName():void
    {
        textInput("userName").selectAllText().typeText("");
    }

    [DomainStep('I cleared password')]
    public function clearPassword():void
    {
        textInput("password").selectAllText().typeText("");
    }

    [DomainStep('The submit button is disabled')]
    public function verifyLoginButtonIsDisabled():void
    {
        poll().assert(button("submitLogin").button, "enabled").equals(false);
    }

    [DomainStep("I entered user name '(.*)' and password '(.*)'")]
    public function enterUserNameAndPassword(userName:String, password:String):void
    {
        textInput("userName").typeText(userName);
        textInput("password").typeText(password);
    }

    [DomainStep("I submit credentials")]
    public function submitLogin():void
    {
        button("submitLogin").click();
    }

    [DomainStep("The welcome screen is shown")]
    public function verifyWelcomeScreenIsShown():void
    {
        var app:SampleApp = container(":SampleApp").component;
        poll().assert(app, "currentState").equals("welcomeScreen");
    }

}
}