package stories
{
import flash.events.Event;

import flexunit.framework.TestCase;

import mx.core.Application;
import mx.events.FlexEvent;
import mx.managers.ISystemManager;

import org.givwenzen.integration.flexunit3.BeforeTest;
import org.morefluent.integrations.flexunit3.integrate;
import org.uinput.install;

public class ApplicationStartup implements BeforeTest
{
    public function ApplicationStartup()
    {
    }

    public function run(testCase:TestCase, testExecutionFunction:Function):void
    {
        // needed by morefluent
        integrate(testCase);

        if (!applicationInitialized())
        {
            var sampleApp:SampleApp = new SampleApp();
            // make sure the test is not executed before the components are ready
            sampleApp.addEventListener(FlexEvent.CREATION_COMPLETE, function (e:Event):void
            {
                testExecutionFunction();
            });
            // adds the application
            installComponent(sampleApp, testExecutionFunction);
            // needed by u-input
            install(sampleApp);
        }
        else
        {
            testExecutionFunction();
        }
    }

    private function applicationInitialized():Boolean
    {
        var systemManager:ISystemManager = Application(Application.application).systemManager;
        return (systemManager.getChildAt(0) is SampleApp);
    }

    private function installComponent(sampleApp:SampleApp, testExecutionFunction:Function):void
    {
        var application:Application = Application(Application.application);
        var systemManager:ISystemManager = application.systemManager;
        systemManager.removeChild(application);
        systemManager.addChild(sampleApp);
    }
}
}